'A simple 2D raycasting demo, hopefully explaining
'how a 3D one works....
DIM MAP%(1 TO 20, 1 TO 20)      'Create the map...
FOR xm = 1 TO 20           'Read in the map
 FOR ym = 1 TO 20
  READ m
  MAP%(ym, xm) = m
 NEXT
NEXT
PRINT "A demo to show the rays emitted from a 'camera'"
PRINT "The coloured blocks you see are the 'walls' you"
PRINT "would see if the data returned from the 'camera'"
PRINT "was translated into a 3D view"
PRINT "Try using the arrow keys to turn/move around and"
PRINT "see what happens...."
SLEEP
SCREEN 13
X = 30
Y = 30
DRAWS:
FOR ro = rot - .5 TO rot + .5 STEP .05
 A = A + 1
 RAYX = X
 RAYY = Y
 DO                           'Fire the ray!
 DIST = DIST + .3             'Keep the distance in mind, needed for the 3D
                              'view
 RAYX = RAYX + COS(ro)        'The ray's X & Y position is increased
 RAYY = RAYY + SIN(ro)       'by adding the angle of the camera
TX = INT(RAYX / 10)           'Get the basic map position of the ray
                              '(Whole number only)
TY = INT(RAYY / 10)
IF TX < 1 THEN TX = 1
IF TY < 1 THEN TY = 1
IF TX > 20 THEN TX = 20
IF TY > 20 THEN TY = 20
COL = MAP%(TX, TY)
PSET (RAYX, RAYY), 15
IF RAYX > 320 THEN DIST = 0: GOTO NXT
IF RAYY > 200 THEN DIST = 0: GOTO NXT
'If the ray has hit something which isn't black, stop the ray and draw the
' 'wall' that it's hit
IF COL > 0 THEN PSET (RAYX, RAYY), COL: LINE (TX * 10, TY * 10)-(TX * 10 + 10, TY * 10 + 10), COL, BF: DIST = 0: GOTO NXT
LOOP
NXT:
NEXT
A = 0
DO                            'Do the key reading bit...
H$ = INKEY$
IF H$ = CHR$(0) + CHR$(77) THEN rot = rot + .1: CLS : GOTO DRAWS
IF H$ = CHR$(0) + CHR$(75) THEN rot = rot - .1: CLS : GOTO DRAWS
IF H$ = CHR$(0) + CHR$(72) THEN
X = X + COS(rot) * 2
Y = Y + SIN(rot) * 2
CLS
GOTO DRAWS
END IF
IF H$ = CHR$(0) + CHR$(80) THEN
X = X - COS(rot) * 2
Y = Y - SIN(rot) * 2
CLS
GOTO DRAWS
END IF
LOOP
'Data for a 20x20 map...
DATA 1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,4,0,0,0,0,4,0,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,4,4,4,4,0,0,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1

