'A simple 3D raycaster, uses the source from the 2D one but has been modified
'to look 3D, also uses a new palette so it can have the 'further away things
'look darker' effect!
'Okay okay! I admit this is *SLOOOOOOOOOW!!* but it can be done a lot faster
'
DIM MAP%(1 TO 20, 1 TO 20)      'Create the map...
FOR xm = 1 TO 20           'Read in the map
 FOR ym = 1 TO 20
  READ m
  MAP%(ym, xm) = m
 NEXT
NEXT
PRINT "This demo is similar to the 2D one, accept that"
PRINT "it draws the returned values from the 'camera'"
PRINT "in a 3D way.."

SLEEP
SCREEN 13
'Set up the palette
FOR col% = 0 TO 255
OUT &H3C8, col%
OUT &H3C9, col% / 3
OUT &H3C9, col% / 3
OUT &H3C9, col% / 3
NEXT



X = 30
Y = 30
DRAWS:
FOR ro = rot - 2 TO rot + 2 STEP .05
 A = A + 1
 RAYX = X
 RAYY = Y
 DO                           'Fire the ray!
 DIST = DIST + .3             'Keep the distance in mind, needed for the 3D...
                              '
 RAYX = RAYX + COS(ro)        'The ray's X & Y position is increased
 RAYY = RAYY + SIN(ro)        'by adding the angle of the camera
 TX = INT(RAYX / 10)           'Get the basic map position of the ray
                              '(Whole number only)
TY = INT(RAYY / 10)
IF TX < 1 THEN TX = 1
IF TY < 1 THEN TY = 1
IF TX > 20 THEN TX = 20
IF TY > 20 THEN TY = 20
col = MAP%(TX, TY)
IF RAYX > 320 THEN DIST = 0: GOTO NXT
IF RAYY > 200 THEN DIST = 0: GOTO NXT
'If the ray has hit something, draw it in 3D!
'Well, this works by drawing a line along (corresponding to the ray the
' 'camera' has fired) and taking the distance of the hit object
'from the vertical length of the line, this gives the distance
'effect....
IF col > 0 THEN LINE (A * 4, 50 + DIST * 2)-(A * 4 + 4, 150 - DIST * 2), col * 10 - (DIST / 2) * 20, BF: DIST = 0: GOTO NXT

LOOP
NXT:
NEXT
COLOR 100: PRINT "Phew, drawn the screen at last!"
A = 0
DO                            'Do the key reading bit...
H$ = INKEY$
IF H$ = CHR$(0) + CHR$(77) THEN rot = rot + .1: CLS : GOTO DRAWS
IF H$ = CHR$(0) + CHR$(75) THEN rot = rot - .1: CLS : GOTO DRAWS
IF H$ = CHR$(0) + CHR$(72) THEN
X = X + COS(rot) * 2
Y = Y + SIN(rot) * 2
CLS
GOTO DRAWS
END IF
IF H$ = CHR$(0) + CHR$(80) THEN
X = X - COS(rot) * 5
Y = Y - SIN(rot) * 5
CLS
GOTO DRAWS
END IF
LOOP
'Data for a 20x20 map...
DATA 1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2
DATA 1,9,9,9,9,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1
DATA 1,9,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,1
DATA 1,9,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,1
DATA 1,9,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,4,0,0,0,0,4,0,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,0,4,4,4,4,0,0,0,1,0,0,0,0,0,0,0,0,0,1
DATA 1,1,1,1,1,1,1,1,1,1,9,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1

